SourceUnit (groovy 2.4.7 API)
Date: 2016-06-03

Package: org.codehaus.groovy.control

## [Java] Class SourceUnit

- org.codehaus.groovy.control.SourceUnit

- Provides an anchor for a single source unit (usually a script file) as it passes through the compiler system.

  Authors:
    Chris Poirier
    Bing Ran

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected ModuleNode` | `ast` | The root of the Abstract Syntax Tree for the source
    `protected Reduction` | `cst` | A Concrete Syntax Tree of the source
    `protected String` | `name` | A descriptive name of the source unit.
    `protected ReaderSource` | `source` | Where we can get Readers for our source unit

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class ProcessingUnit` | `classLoader, configuration, errorCollector, phase, phaseComplete`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `SourceUnit (String name, ReaderSource source, CompilerConfiguration flags, GroovyClassLoader loader, ErrorCollector er)` Initializes the SourceUnit from existing machinery.
    `SourceUnit (File source, CompilerConfiguration configuration, GroovyClassLoader loader, ErrorCollector er)` Initializes the SourceUnit from the specified file.
    `SourceUnit (URL source, CompilerConfiguration configuration, GroovyClassLoader loader, ErrorCollector er)` Initializes the SourceUnit from the specified URL.
    `SourceUnit (String name, String source, CompilerConfiguration configuration, GroovyClassLoader loader, ErrorCollector er)` Initializes the SourceUnit for a string of source.

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `addError(SyntaxException se)` This method adds a SyntaxException to the error collector.
    `void` | `addException(Exception e)` This method adds an exception to the error collector.
    `void` | `convert()` Generates an AST from the CST.
    `static SourceUnit` | `create(String name, String source)` A convenience routine to create a standalone SourceUnit on a String with defaults for almost everything that is configurable.
    `static SourceUnit` | `create(String name, String source, int tolerance)` A convenience routine to create a standalone SourceUnit on a String with defaults for almost everything that is configurable.
    `boolean` | `failedWithUnexpectedEOF()` Convenience routine, primarily for use by the InteractiveShell, that returns true if parse() failed with an unexpected EOF.
    `ModuleNode` | `getAST()` Returns the Abstract Syntax Tree produced during convert()ing and expanded during later phases.
    `Reduction` | `getCST()` Returns the Concrete Syntax Tree produced during parse()ing.
    `String` | `getName()` Returns the name for the SourceUnit.
    `String` | `getSample(int line, int column, Janitor janitor)` Returns a sampling of the source at the specified line and column, or null if it is unavailable.
    `ReaderSource` | `getSource()`
    `protected boolean` | `isEofToken(Token token)`
    `void` | `parse()` Parses the source to a CST.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ProcessingUnit` | `completePhase, configure, getClassLoader, getConfiguration, getErrorCollector, getPhase, getPhaseDescription, gotoPhase, nextPhase, setClassLoader, setConfiguration`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### protected ModuleNode ast

      The root of the Abstract Syntax Tree for the source

    - #### protected Reduction cst

      A Concrete Syntax Tree of the source

    - #### protected String name

      A descriptive name of the source unit. This name shouldn't be used for controlling the SourceUnit, it is only for error messages and to determine the name of the class for a script.

    - #### protected ReaderSource source

      Where we can get Readers for our source unit

  - ### Constructor Detail

    - #### public SourceUnit(String name, ReaderSource source, CompilerConfiguration flags, GroovyClassLoader loader, ErrorCollector er)

      Initializes the SourceUnit from existing machinery.

    - #### public SourceUnit(File source, CompilerConfiguration configuration, GroovyClassLoader loader, ErrorCollector er)

      Initializes the SourceUnit from the specified file.

    - #### public SourceUnit(URL source, CompilerConfiguration configuration, GroovyClassLoader loader, ErrorCollector er)

      Initializes the SourceUnit from the specified URL.

    - #### public SourceUnit(String name, String source, CompilerConfiguration configuration, GroovyClassLoader loader, ErrorCollector er)

      Initializes the SourceUnit for a string of source.

  - ### Method Detail

    - #### public void addError(SyntaxException se)

      This method adds a SyntaxException to the error collector. The exception should specify the line and column number of the error. This method should be reserved for real errors in the syntax of the SourceUnit. If your error is not in syntax, and is a semantic error, or more general error, then use addException or use the error collector directly by retrieving it with getErrorCollector().

      throws:
        CompilationFailedException on error
      Parameters:
        `se` - the exception, which should have line and column information

    - #### public void addException(Exception e)

      This method adds an exception to the error collector. The Exception most likely has no line number attached to it. For this reason you should use this method sparingly. Prefer using addError for syntax errors or add an error to the ErrorCollector directly by retrieving it with getErrorCollector().

      throws:
        CompilationFailedException on error
      Parameters:
        `e` - the exception that occurred

    - #### public void convert()

      Generates an AST from the CST. You can retrieve it with getAST().

    - #### public static SourceUnit create(String name, String source)

      A convenience routine to create a standalone SourceUnit on a String with defaults for almost everything that is configurable.

    - #### public static SourceUnit create(String name, String source, int tolerance)

      A convenience routine to create a standalone SourceUnit on a String with defaults for almost everything that is configurable.

    - #### public boolean failedWithUnexpectedEOF()

      Convenience routine, primarily for use by the InteractiveShell, that returns true if parse() failed with an unexpected EOF.

    - #### public ModuleNode getAST()

      Returns the Abstract Syntax Tree produced during convert()ing and expanded during later phases.

    - #### public Reduction getCST()

      Returns the Concrete Syntax Tree produced during parse()ing.

    - #### public String getName()

      Returns the name for the SourceUnit. This name shouldn't be used for controlling the SourceUnit, it is only for error messages

    - #### public String getSample(int line, int column, Janitor janitor)

      Returns a sampling of the source at the specified line and column, or null if it is unavailable.

    - #### public ReaderSource getSource()

    - #### protected boolean isEofToken(Token token)

    - #### public void parse()

      Parses the source to a CST. You can retrieve it with getCST().